// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 3
#define UNFILLED 0
#define USED 0

typedef int BOOL;

int main(void)		// Called at program startup
{
	int i, j, k;
	int temp;		// To swap in step 3, to reverse sequence in step 4
	int g_count;	// Number of permutations generated
	int max_integer;
	int num_of_unfilled;
	int g_array[SIZE + 1][SIZE + 1];
	int unfilled_row[SIZE * SIZE + 1];
	int unfilled_column[SIZE * SIZE + 1];
	int unused_integer[SIZE * SIZE + 1];
	int row, column;
	int g_target_sum;
	int sum;
	BOOL is_last_permutation;
	BOOL is_legal;
	
	max_integer = SIZE * SIZE;
	for (i = 1; i <= max_integer; i++) {
		unused_integer[i] = i;
	}

printf("35\n"); //

	num_of_unfilled = 0;
	for (i = 1; i <= SIZE; i++) {
		for (j = 1; j <= SIZE; j++) {
			scanf("%d", &g_array[i][j]);
//			g_array[i][j] = 0;

			if (g_array[i][j] == UNFILLED) {
				num_of_unfilled++;
				unfilled_row[num_of_unfilled] = i;
				unfilled_column[num_of_unfilled] = j;
			} else {
				unused_integer[g_array[i][j]] = USED;
			}
		}
	}

printf("%d ", unfilled_row[1]);
printf("%d ", unfilled_row[2]);
printf("%d ", unfilled_row[3]);
printf("%d ", unfilled_row[4]);
printf("%d ", unfilled_row[5]);
printf("%d ", unfilled_row[6]);
printf("%d ", unfilled_row[7]);
printf("%d ", unfilled_row[8]);
printf("%d\n", unfilled_row[9]);
printf("%d ", unfilled_column[1]);
printf("%d ", unfilled_column[2]);
printf("%d ", unfilled_column[8]);
printf("%d\n", unfilled_column[9]);

	for (i = 1; i <= max_integer; i++) {
		for (k = i; !unused_integer[k] && k <= max_integer; k++) ;
		unused_integer[i] = unused_integer[k];
		if (i != k) {
			unused_integer[k] = USED;
		}
	}

printf("%d ", unused_integer[1]);
printf("%d ", unused_integer[2]);
printf("%d ", unused_integer[3]);
printf("%d ", unused_integer[4]);
printf("%d ", unused_integer[5]);
printf("%d ", unused_integer[6]);
printf("%d ", unused_integer[7]);
printf("%d ", unused_integer[8]);
printf("%d\n", unused_integer[9]);

	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;

	g_count = 0;
	is_last_permutation = FALSE;
	while (!is_last_permutation) {

/*
printf("%d ", unused_integer[1]);
printf("%d ", unused_integer[2]);
printf("%d ", unused_integer[3]);
printf("%d ", unused_integer[4]);
printf("%d ", unused_integer[5]);
printf("%d ", unused_integer[6]);
printf("%d ", unused_integer[7]);
printf("%d ", unused_integer[8]);
printf("%d\n", unused_integer[9]);
*/

		for (i = 1; i <= num_of_unfilled; i++) {
			row = unfilled_row[i];
			column = unfilled_column[i];
			g_array[row][column] = unused_integer[i];
		}

/*
for(i=1;i<=9;i++){
for(j=1;j<=9;j++){
printf("%d",g_array[i][j]);
}
}
*/
/*
for(i=1;i<=9;i++){
printf("%d" ,unfilled_row[i]);
}
*/

		is_legal = TRUE;
		if (is_legal) {
printf("b125");
			for (i = 1; i <= SIZE; i++) {
				sum = 0;
				for (j = 1; j <= SIZE; j++) {
					sum += g_array[i][j];
				}
printf("sum%d ",sum);
				if (sum != g_target_sum) {
printf("b133f ");
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
printf("b137 ");
			for (j = 1; j <= SIZE; j++) {
				sum = 0;
				for (i = 1; i <= SIZE; i++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
printf("b149 ");
			sum = 0;
			for (i = 1, j = 1; i <= SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
printf("b159 ");
			sum = 0;
			for (i = 1, j = SIZE; i <= SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			printf("Solution %d:\n", ++g_count);
			for (i = 1; i <= SIZE; i++) {
				for (j = 1; j <= SIZE; j++) {
					printf("%4d", g_array[i][j]);
				}
				printf("\n");
			}
			printf("\n");
		}
		for (j = num_of_unfilled - 1; j && unused_integer[j] > unused_integer[j + 1]; j--) ; // Step 1 find index j
		if (!j) {
			is_last_permutation = TRUE;
		}
		for (k = num_of_unfilled; unused_integer[j] > unused_integer[k]; k--) ;				  // Step 2 find index k
		temp = unused_integer[j];		//
		unused_integer[j] = unused_integer[k];		// Step 4 mirror the elements by reflection
		unused_integer[k] = temp;		//
		k++;
		i = num_of_unfilled;
		while (k < i) { // Step 4 to reverse A[j + 1] ~ A[N - 1]
			temp = unused_integer[k];		//
			unused_integer[k] = unused_integer[i];		// Step 4 mirror the elements by reflection
			unused_integer[i] = temp;		//
			k++;
			i--;
		}
	}
	printf("Number of solutions found: %d\n", g_count);
	return 0;	// Indicates normal program termination
}
